Subject: [IPP] Fwd: "pwgraster-lint" tool?

From: "Kennedy, Smith (Wireless Architect)" <[email-masked]>
Date: Thu, 16 Mar 2017 20:38:51 +0000

Greetings,

This was privately discussed before being discussed at today's IPP WG meeting, so re-posting for posterity. Notes from today's meeting (recorded in mintutes at: http://ftp.pwg.org/pub/pwg/ipp/minutes/ippv2-concall-minutes-20170316.pdf <http://ftp.pwg.org/pub/pwg/ipp/minutes/ippv2-concall-minutes-20170316.pdf>) on this subject:

Possible pwgraster-lint tool (Smith/Mike)

⁃ email discussion on 03/14/17
⁃ Smith will forward message thread to IPP mailing list

⁃ Issue #29 in ippsample project:
⁃ https://github.com/istopwg/ippsample/issues/29

⁃ Discussion:

⁃  Also use for a future IPP Transform service, using a generic "lint

report" MIME media type so that (in theory) any document format

could be validated.

⁃  Have OpenPrinting volunteers to write code as needed for different

formats.

⁃  Known issues with reporting problems with PDF/PostScript since it

is hard to report on where the problem is (page number or PDF object number are more feasible than file offsets)

⁃ Will talk with Artifex developers for their feedback 

Smith

/**
    Smith Kennedy
    Wireless Architect - Client Software - IPG-PPS
    Standards - IEEE ISTO PWG / Bluetooth SIG / Wi-Fi Alliance / NFC Forum / USB IF
    Chair, IEEE ISTO Printer Working Group
    HP Inc.
*/

> Begin forwarded message:
> 
> From: Smith Kennedy <[email-masked]>
> Subject: Re: "pwgraster-lint" tool?
> Date: March 14, 2017 at 11:25:33 AM MDT
> To: Michael Sweet <[email-masked]>
> Cc: Ira McDonald <[email-masked]>
> 
> Thanks Mike!
> 
> https://github.com/istopwg/ippsample/issues/29 <https://github.com/istopwg/ippsample/issues/29>
> 
> 
> 
> 
>> On Mar 14, 2017, at 10:51 AM, Michael Sweet <[email-masked] <mailto:[email-masked]>> wrote:
>> 
>> Smith,
>> 
>>> On Mar 14, 2017, at 12:23 PM, Kennedy, Smith (Wireless Architect) <[email-masked] <mailto:[email-masked]>> wrote:
>>> 
>>> Hi Mike,
>>> 
>>> Do we have any tools that can validate the structure of a PWG Raster file?
>> 
>> Nothing specifically right now; the CUPS raster code reports fairly detailed error messages when it runs into issues, so it would be pretty trivial to write a "pwgraster-lint" tool that just read a raster file and reported statistics (number of pages, etc.) along with any errors during reading.
>> 
>>> I had wondered if ipptransform might be used for this, but the man page doesn't list "image/pwg-raster" as a supported input format.
>> 
>> I should check that; in theory it should be able to do it as long as the resolution, color space, and bit depth is compatible (and otherwise throw an error) but right now I think it just does the PDF and JPEG to PWG Raster or PCL conversion.
>> 
>>> If not, I can add an "enhancement" to ippsample to have such a tool created, as a reminder.
>> 
>> Go ahead and create an issue tracking this and a PDF and JPEG validator.
>> 
>>> Would that be hard to write? Such a tool would be a good validator to be used by ippserver. And an equivalent tool would be good to validate the structure of PDF - guessing "mutool' might be a good candidate for that.
>> 
>> Well, maybe.  One of the "problems" with mupdf and Ghostscript is that they won't show you the location of the error, just that there is an error.  About the best you can get is "page N contains an error".
>> 
>> _________________________________________________________
>> Michael Sweet, Senior Printing System Engineer
>> 
> 

_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp